import urllib2
from cookielib import CookieJar
import logging

HTTP_CLIENT_TIMEUOT = 3

logger = logging.getLogger()


class HTTPClient:
    def __init__(self):
        self.cookies = CookieJar()
        self.opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(self.cookies))
        self.opener.addheaders = [('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; it; rv:1.8.1.11) Gecko/20071127 Firefox/2.0.0.11')]

    def get_page(self, url):
        logger.debug('HTTP_Client get_page %s' % url)
        res = self.opener.open(url, timeout=HTTP_CLIENT_TIMEUOT)
        if res.getcode() == 200:
            return res.read()
        else:
            raise Exception('http client get_page return not 200, fix me')

    def post_data(self, url, data, headers={}):
        logger.debug('HTTP_Client post_data %s' % url)
        request = urllib2.Request(url, data, headers=headers)
        request.get_method = lambda: 'POST'
        res = self.opener.open(request, timeout=HTTP_CLIENT_TIMEUOT)
        if res.getcode() == 200:
            return res.read()
        else:
            raise Exception('http client get_page return not 200, fix me')


def test_http_client():
    http_client = HTTPClient()
    print http_client.get_page('http://ya.ru/')


if __name__ == '__main__':
    test_http_client()
